<!DOCTYPE>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<meta content="charset=UTF-8"/>
<title>Change Vis</title>
<!--STYLESHEET-->
<link type="text/css" rel="stylesheet" href="stylesheet/3dhop.css"/>  
<!--SPIDERGL-->
<script type="text/javascript" src="js/spidergl.js"></script>
<!--JQUERY-->
<script type="text/javascript" src="js/jquery.js"></script>
<!--PRESENTER-->
<script type="text/javascript" src="js/presenter.js"></script>
<!--3D MODELS LOADING AND RENDERING-->
<script type="text/javascript" src="js/nexus.js"></script>
<!--TRACKBALLS-->
<script type="text/javascript" src="js/trackball_sphere.js"></script>
<!--UTILITY-->
<script type="text/javascript" src="js/init.js"></script>
<script type="text/javascript" src="js/dat.gui.js"></script>
</head>
<body>
<div id="3dhop" class="tdhop" onmousedown="if (event.preventDefault) event.preventDefault()">
 <div id="toolbar">
  <img id="home"     title="Home"                  src="skins/minimal_light/home.png"   /><br/>
  <img id="zoomin"   title="Zoom In"               src="skins/minimal_light/zoomin.png" /><br/>
  <img id="zoomout"  title="Zoom Out"              src="skins/minimal_light/zoomout.png"/><br/>
  <img id="light_on" title="Disable Light Control" src="skins/minimal_light/light_on.png" style="position:absolute; visibility:hidden;"/>
  <img id="light"    title="Enable Light Control"  src="skins/minimal_light/light.png"/><br/>
  <img id="full_on"  title="Exit Full Screen"      src="skins/minimal_light/full_on.png" style="position:absolute; visibility:hidden;"/>
  <img id="full"     title="Full Screen"           src="skins/minimal_light/full.png"   /><br/>
  <img id="help_on"  title="Hide Help"             src="skins/minimal_light/help_on.png"  style="position:absolute; visibility:hidden;"/>
  <img id="help"     title="Show Help"             src="skins/minimal_light/help.png"   />
 </div>
 <div id="helpDiv">
	<h2>Quick Help</h2>
	<table>
	  <tr><td>Drag:</td><td>Rotate</td></tr>
	  <tr><td>Wheel:</td><td>Zoom</td></tr>
	  <tr><td>Ctrl+Drag:</td><td>Pan</td></tr>
	  <tr><td>Drag+Press Wheel:</td><td>Pan</td></tr>
	  <tr><td>Alt-Wheel:</td><td>Z-Panning</td></tr>
	  <tr><td>Double Click:</td><td>Recentering</td></tr>
	  <tr><td>Left Arrow Key:</td><td>Decrease Time</td></tr>
	  <tr><td>Right Arrow Key:</td><td>Increase Time</td></tr>
	</table>
 </div>
 <canvas id="draw-canvas"/>
</div>
<form id = "timeForm">
  <input id = "timeSlider" type="range" name="time" min="0" max="100" value="0">
</form>

<script type="text/javascript">
var presenter = null;
var timeControl = null;
var timeController = null;

function setup3dhop() { 
	presenter = new Presenter("draw-canvas");

	presenter.setScene({
		meshes: {
			"mesh_0" : { url: "<?php echo $_GET['model1']; ?>"},
			"mesh_1" : { url: "<?php echo $_GET['model2']; ?>"}
		},
		modelInstances : {
			"model_0" : {
				mesh : "mesh_0",
				color: [0.5, 0.5, 1.0]
			},
			"model_1" : {
				mesh : "mesh_1",
				color: [0.5, 0.5, 1.0]
			}
		},
		trackball: {
			type: SphereTrackball,
			trackOptions: {
				minMaxScale: [0.003, 10]
			}
		},
		space: {
			cameraNearFar: [0.1, 50]
		},
		background: {
			color: [0.0, 0.0, 0.0, 0.0]
		}
		
	});
	
	
	var Controller = function() {
		this.time = 0.0; 
		this.changeThreshold = <?php if (isset($_GET['change'])){echo $_GET['change'];}else{echo 0.5;} ?>;
		this.deltaChange = 0.15;
		this.mapChangeOnColor = false;
		this.meshColor = true;
		this.exponent = 0.05;
		this.normalInterpolation = true;
		this.colorRamp = 1;
		this.method = "0";
	};
	
	
	
	timeControl = new Controller();
	<?php 
		if (isset($_GET['animation']))
			echo "presenter.isAnimating = true;";
		echo "var gui = new dat.GUI({ width : 400});";
		if (isset($_GET['debug']))
			echo "var methodController = gui.add(timeControl, 'method', { 'SmoothStep1': 0, 'SmoothStep2': 1, 'Linear': 2, 'Switch': 3} ).name('Method');
			methodController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});";
		echo 
			"var thresholdController = gui.add(timeControl, 'changeThreshold', 0.0, 1.0).name('Change threshold');
			//var deltaController = gui.add(timeControl, 'deltaChange', 0.0, 0.5).name('Delta change');
			var colorController = gui.add(timeControl, 'mapChangeOnColor').name('Map change on color');
			var colorRampController = gui.add(timeControl, 'colorRamp', { 'RGB': 0, 'Blue-White-Red': 1} ).name('Color ramp');
			var meshColorController = gui.add(timeControl, 'meshColor').name('Use mesh color');
			//var exponentController = gui.add(timeControl, 'exponent', 0.0, 1.0).name('Smooth step');
			var normalController = gui.add(timeControl, 'normalInterpolation').name('Use normal interpolation');
			
			thresholdController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});
			//deltaController.onChange(function(value) {presenter.ui.postDrawEvent();});
			colorController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});
			colorRampController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});
			meshColorController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});
			//exponentController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});
			normalController.onFinishChange(function(value) {presenter.ui.postDrawEvent();});";
	?>
	presenter._userControl = timeControl;
	
}

function actionsToolbar(action) {
	if(action=='home') presenter.resetTrackball(); 
	else if(action=='zoomin') presenter.zoomIn();
	else if(action=='zoomout') presenter.zoomOut(); 
	else if(action=='light' || action=='light_on') { presenter.enableLightTrackball(!presenter.isLightTrackballEnabled()); lightSwitch(); } 
	else if(action=='full'  || action=='full_on') fullscreenSwitch(); 
	else if(action=='help' || action=='help_on') showHelp();
}

$(document).ready(function(){
	init3dhop();
	setup3dhop();
});
</script>
</body>
</html>
